<?php

    $atts = vc_map_get_attributes( $this->getShortcode(), $atts );
    extract( $atts );

    $attrs = array();

    $classes = array();

    $styles = array();

    $classes[] = 'w-image';

    if( !empty($alignment) ){
        $classes[] = 'text-'.$alignment;
    }       

    if( !empty($el_class) ){
        $classes[] = $el_class;
    }

    if( !empty($css) ){
        $classes[] = vc_shortcode_custom_css_class( $css, '' );    
    }    


    $img_id = preg_replace( '/[^\d]/', '', $image );
    $img = wp_get_attachment_image_src( $img_id, $img_size );

    if( isset($img[0]) ):
   
        $link_attrs = array();
        $full_image = array();

        if ( !empty($onclick) ) {

            if( $onclick === 'custom_link' ){

                if( !empty($link) ){
                    $link_attrs['href'] = esc_url( $link ); 
                }                 

                if( !empty($link_target) ){
                    $link_attrs['target'] = trim( $link_target );
                } 

            }else{                

                if( $img_size != 'full'){
                    $full_image = wp_get_attachment_image_src( $img_id, 'full' );
                }else{
                    $full_image = $img;    
                }     

                if( isset($full_image[0]) ){
                    $link_attrs['href'] = esc_url( $full_image[0] ); 
                }

                if( $onclick === 'link_image' ){
                   $link_attrs['data-rel'] = 'prettyPhoto'; 
                }else{
                    $link_attrs['target'] = $link_target;
                }        

            }                          
            
        }
        

        $image_alt =  get_post_meta($img_id, '_wp_attachment_image_alt', true);       

        if( !empty($responsive) ){
            $classes[] = 'w-responsive';
        }

        if( !empty($style) ){

            $classes[] = 'w-'.$style;

            if( !empty($border_color) ){
                $styles[] = 'border-color:'.$border_color;
            }
        }          

        $attrs['class'] = implode(' ', $classes);

    
        $attrs['style'] = implode(';', $styles);        

        if($animation) $attrs['data-animation'] = $animation;
        if($animation_delay) $attrs['data-animation-delay'] = floatval( $animation_delay );   


?>
<div<?php echo wyde_get_attributes( $attrs );?>>
    <?php   
    if( !empty($responsive) ){
        echo '<div style="background-image:url(\''.$img[0].'\')"></div>';
    } 
    if( isset($link_attrs['href']) ):
        echo '<a'.wyde_get_attributes( $link_attrs ).'>';
    endif;    
    ?>
    <img src="<?php echo esc_attr( $img[0] ); ?>" alt="<?php echo esc_attr($image_alt); ?>" />
    <?php
    if( isset($link_attrs['href']) ):
    echo '</a>';
    endif;
    ?>
</div>
<?php endif; ?>