<?php
/**
 * The template for displaying product content within loops
 *
 * This template can be overridden by copying it to yourtheme/woocommerce/content-product.php.
 *
 * HOWEVER, on occasion WooCommerce will need to update template files and you (the theme developer).
 * will need to copy the new files to your theme to maintain compatibility. We try to do this.
 * as little as possible, but it does happen. When this occurs the version of the template file will.
 * be bumped and the readme will list any important changes.
 *
 * @see     http://docs.woothemes.com/document/template-structure/
 * @author  WooThemes
 * @package WooCommerce/Templates
 * @version 2.5.0
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}

global $product, $woocommerce_loop;

// Store loop count we're currently on
if ( empty( $woocommerce_loop['loop'] ) )
	$woocommerce_loop['loop'] = 0;

// Store column count for displaying the grid
if ( empty( $woocommerce_loop['columns'] ) ){
	$woocommerce_loop['columns'] = apply_filters( 'loop_shop_columns', 4 );
}

// Ensure visibility
if ( ! $product || ! $product->is_visible() )
	return;

// Increase loop count
$woocommerce_loop['loop']++;

$grid_columns = intval( $woocommerce_loop['columns'] );
if( !$grid_columns ) $grid_columns = 4;
// Extra post classes
$classes = array();
$classes[] = 'w-item';
$classes[] = 'col-'.  absint( floor(12/ $grid_columns ) ); 

?>
<li <?php post_class( $classes ); ?>>
    <figure>      
    	<div class="image-wrapper">      
        <?php 
        /**
		 * woocommerce_before_shop_loop_item hook.
		 *
		 * @hooked woocommerce_template_loop_product_link_open - 10
		 */
		do_action( 'woocommerce_before_shop_loop_item' );

		/**
		 * woocommerce_before_shop_loop_item_title hook.
		 *
		 * @hooked woocommerce_show_product_loop_sale_flash - 10
		 * @hooked woocommerce_template_loop_product_thumbnail - 10
		 */
		do_action( 'woocommerce_before_shop_loop_item_title' );		
	    ?>
		</div>
        <figcaption>
	        <h3>
        	<?php 
        	/**
			 * woocommerce_shop_loop_item_title hook.
			 *
			 * @hooked woocommerce_template_loop_product_title - 10
			 */
			do_action( 'woocommerce_shop_loop_item_title' );
	        ?>
	    	</h3>
	        <?php
		        /**
			        * woocommerce_after_shop_loop_item_title hook
			        *
			        * @hooked woocommerce_template_loop_rating - 5
			        * @hooked woocommerce_template_loop_price - 10
			        */
		        do_action( 'woocommerce_after_shop_loop_item_title' );
	        ?>
        </figcaption>
        <?php

		    /**
		        * woocommerce_after_shop_loop_item hook
		        *
		        * @hooked woocommerce_template_loop_add_to_cart - 10
		        */
		    do_action( 'woocommerce_after_shop_loop_item' ); 

	    ?>
    </figure>
</li>